 LIST P=12F629, R=DEC    ; Use the PIC12F629 and decimal system 
;===============================================================================
; Autoalarm verze 0.1  23.12.2006
; Jan Matuska, honzamat@atlas.cz
;===============================================================================

 #include "P12F629.INC"  ; Include header file 

; __config  _INTRC_OSC_NOCLKOUT & _WDT_ON & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF 
 __config  _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF 


; definice promennych 20H az do moznych 5FH
cas0        equ 23H  ; generovani casovych prodlev
cas1        equ 24H  ; generovani casovych prodlev
cas2        equ 25H  ; generovani casovych prodlev
stav        equ 26H            
cntdown     equ 27H
tmp         equ 28H

; bity  
foundkey    equ 0H

; vystupy
sirena      equ 04H  ; vystup na sirenu do prostoru auta, PullUP ON
led         equ 00H  ; vystup na vystaznou ledku. Sviti v L, PullUP OFF porad
pwr         equ 05H  ; vystup pro drzeni relatka napajeni
keyA        equ 01H
keyB        equ 02H

;--- nastaveni dat v EEPROM ---
	org	0x2100		
	de	0,0


               ORG 0
               goto start


; Casovaci rutiny -----------------------------------------------------------

  ; ceka 10 ms
Delay10ms      movlw .13  
               movwf cas1
               movlw .255  
               movwf cas0
               decfsz cas0,f
               goto $-1
               decfsz cas1,f
               goto $-5
               clrwdt
               return
  ; ceka 20ms
Delay20ms      call Delay10ms
               call Delay10ms
               return

  ; ceka 100ms
Delay100ms     movlw .10
               movwf cas2
               call Delay10ms
               decfsz cas2,f
               goto $-2
               return
  ; ceka 1s
Delay1s        movlw .100
               movwf cas2
               call Delay10ms
               decfsz cas2,f
               goto $-2
               return

; ##############################################################################
; Zacatek programu a inicializace ----------------------------------------------
start          bcf STATUS,RP0      ;>>BANK 0<<
               bcf STATUS,RP1      ;tohle by mela byt vzdycky nula 
               movlw 7             ;7 do W
               movwf CMCON         ;CMCON=7 set comparators off, maly proud   
               bsf STATUS,RP0      ;>>BANK 1<<
               bcf OPTION_REG, 7   ;enable internal pullups
               movlw b'00110001'
               movwf WPU           ;nastavi pullupy na vystupech 4 az 5           
               movlw b'00000000'   ;0=out 1=in
               movwf TRISIO        ;nastavi vstupy a vystupy
               bcf STATUS,RP0      ;>>BANK 0<<
                 ; --- smazani registru a defaultni hodnoty ---
               bsf GPIO, pwr
               bcf GPIO, sirena
               bcf GPIO, led
               call Delay1s        ;cas pro vzpamatovani se
                 ; precteme EEPROM a podle toho se budou dit veci -----               
               clrf tmp          ;0 do pomocne promenne tmp
               movlw 0           ;adresa pro precteni z eeprom   
               call ReadEE        ;obsah eeprom do W
   	         	 subwf tmp,W        ;odecte no2 od W a vysledek do W
		           btfss STATUS,Z     ;je eeprom=0?
		           goto ToAlarm       ;neni, skok na smycku pro vyvolani alarmu
               goto NoAlarm       ;pokracujeme tim, ze alarm vyvolan nebude


; -- stav, kdyz poplach vyvolan nebude ---
NoAlarm        bsf GPIO,led       ;rozsviti LED
               movlw .150
               movwf cntdown
NoAlarm1       call Delay100ms
               call TestKey
               btfsc stav,foundkey
               goto Zakoduj 
               decfsz cntdown,f
               goto NoAlarm1
               bcf GPIO,led       ;zhasne LED
               bcf GPIO,pwr
NoAlarm2       goto NoAlarm2    ; kdyz zustavou otevrene dvere, infinity loop
Zakoduj        bsf STATUS,RP0   ;bank 1               
               movlw 0
               movwf EEADR 
               movlw 1
               movwf EEDATA
               call ProgEE
               call Piskni
               call Delay100ms
               call Delay100ms
               call Delay100ms
               call Delay100ms
               call Piskni
               movlw .20
               movwf cntdown
Zakoduj1       call Delay1s
               bsf GPIO,led
               call Delay1s
               bcf GPIO,led
               decfsz cntdown,f
               goto Zakoduj1
               bcf GPIO,led       ;zhasne LED
               bcf GPIO,pwr
Zakoduj3       goto Zakoduj3    ; pokud do 30-ti sekund po zakodovani nezavrtu dvere





ToAlarm        movlw .80
               movwf cntdown
ToAlarm1       call Delay100ms
               call Blikni
               call TestKey
               btfsc stav,foundkey
               goto Odkoduj 
               decfsz cntdown,f
               goto ToAlarm1
               ; -- zde se zapoji akci clen, tj. sirena
               bsf GPIO,sirena
               bsf STATUS,RP0   ;bank 1
               movlw 1          ; ulozi priznak naruseni do EEPROM na adresu 1
               movwf EEADR 
               movlw 1
               movwf EEDATA
               call ProgEE
               movlw .200
               movwf cntdown
ToAlarm2       call Delay1s
               call TestKey
               btfsc stav,foundkey
               goto Odkoduj 
               call Delay1s
               call TestKey
               btfsc stav,foundkey
               goto Odkoduj 
               call Delay1s
               call TestKey
               btfsc stav,foundkey
               goto Odkoduj 
               decfsz cntdown,f
               goto ToAlarm2
               bcf GPIO,sirena
               bcf GPIO,pwr
ToAlarm3       goto ToAlarm3    ; pokud necha smejd otevrene dvere
Odkoduj        bcf GPIO,sirena
               bsf STATUS,RP0   ;bank 1               
               movlw 0
               movwf EEADR 
               movlw 0
               movwf EEDATA
               call ProgEE
               call Delay100ms
               clrf tmp               
               movlw 1
               call ReadEE
   	         	 subwf tmp,W        ;odecte no2 od W a vysledek do W
		           btfsc STATUS,Z     ;je eeprom=0?
		           goto Odkoduj2       ;ano je, poplach nebyl vyvolan, piskne jen jednou
               call Piskni
               call Piskni
               call Piskni
               call Piskni
Odkoduj2       call Piskni
               bsf STATUS,RP0   ;bank 1               
               movlw 1
               movwf EEADR 
               movlw 0
               movwf EEDATA
               call ProgEE
               call Delay100ms
               bcf GPIO,pwr
Odkoduj3       goto Odkoduj3    ; pokud do 30-ti sekund po zakodovani nezavrtu dvere
                       
Blikni         bsf GPIO,led
               call Delay100ms
               bcf GPIO,led
               return

Piskni         bsf GPIO,sirena
               call Delay10ms
               bcf GPIO,sirena
               call Delay100ms
               call Delay100ms
               return


TestKey        call ReadKey
               btfss stav,foundkey
               return
               call Delay1s
               call ReadKey
               return

; Otestuje vstupy na pritomnost klice a nastavi stav do reg. stav,foundkey
; A=GP1, B=GP2, C=GP3
ReadKey        bcf stav,foundkey   ;defaultni hodnota navrahove hodnoty
               ; test jedna
               bsf STATUS,RP0      ;>>BANK 1<<
               movlw b'00110011'
               movwf WPU           ;nastavi pullup na A        
               movlw b'00001100'   ;A na vystup, B na vstup
               movwf TRISIO        ;nastavi vstupy a vystupy
               bcf STATUS,RP0      ;>>BANK 0<<
               bsf GPIO,keyA
               call Delay10ms
               btfss GPIO,keyB
               return
               call Delay10ms       ;osetreni preskoku
               btfss GPIO,keyB
               return
               bcf GPIO,keyA
               ; prvni test prosel, testujeme jinou variantu
               bsf STATUS,RP0      ;>>BANK 1<<
               movlw b'00110101'
               movwf WPU           ;nastavi pullup na B        
               movlw b'00000010'   ;B na vystup, A na vstup
               movwf TRISIO        ;nastavi vstupy a vystupy
               bcf STATUS,RP0      ;>>BANK 0<<
               bsf GPIO,keyB
               call Delay10ms
               btfsc GPIO,keyA
               return
               call Delay10ms
               btfsc GPIO,keyA
               return
               bcf GPIO,keyB
               ; testy prosly, je vlozen korektni klic a ne zarazeny sroubovak
               bsf stav,foundkey
               return




; ########################################################################
; PRACE S EEPROM...
; ########################################################################

; Cteni z EEPROM. Vstupem je adresa ve W a vystupem jsou data ve W
ReadEE		    bsf STATUS,RP0       ;bank 1
              movwf EEADR          ;W do EEADR
		          bsf EECON1,RD        ;zahajeni cteni
ReadEE1	      btfsc EECON1,RD      ;je RD bit log.1?
		          goto ReadEE1         ;neni
              movfw EEDATA         ;EEDATA do W
		          bcf STATUS,RP0       ;bank 0
		          return               ;navrat


; Zapis do EEPROM. Vstupem je nastavena bank1 a naplnene EEDATA a EEADR
ProgEE		    bsf EECON1,WREN      ;povoleni zapisu
      		    movlw 55h            ;povinna sekvence
      		    movwf EECON2
      		    movlw 0AAh
      		    movwf EECON2
      		    bsf EECON1,WR        ;zapis do EE
ProgEE1	      btfsc EECON1,WR      ;je WR bit log.1?
      		    goto ProgEE1         ;neni
      	 	    bcf STATUS,RP0       ;bank 0
      		    return               ;navrat



 END

